#pragma once
#ifndef AbstractTessellation_h
#define AbstractTessellation_h

#include "Camera.h"
#include "Heightfield.h"

class AbstractTessellation
{
public:
	/// Constructor
	AbstractTessellation(const Heightfield& heightfield, const std::string& name) : mHeightfield(heightfield), mName(name) { }
	/// Destructor
	virtual ~AbstractTessellation() { };
	/// Performs a per-frame update of the tessellation
	virtual void update(const Camera& camera) = 0;
	/// Renders the geometry
	virtual void render(const Camera& camera) = 0;

public:
	const Heightfield& mHeightfield;	///< Reference to the heightfield to tessellate
	std::string mName;					///< Name of the tessellation implementation for debugging
};

#endif